VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3570
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6855
   LinkTopic       =   "Form1"
   ScaleHeight     =   3570
   ScaleWidth      =   6855
   StartUpPosition =   3  'Windows Default
   Begin MSFlexGridLib.MSFlexGrid flxResults 
      Height          =   2415
      Left            =   960
      TabIndex        =   6
      Top             =   1080
      Visible         =   0   'False
      Width           =   5775
      _ExtentX        =   10186
      _ExtentY        =   4260
      _Version        =   393216
      AllowUserResizing=   1
   End
   Begin VB.CommandButton cmdExecute 
      Caption         =   "Execute"
      Enabled         =   0   'False
      Height          =   375
      Left            =   5520
      TabIndex        =   5
      Top             =   600
      Width           =   1215
   End
   Begin VB.TextBox txtCommand 
      Height          =   285
      Left            =   960
      TabIndex        =   3
      Text            =   "SELECT * FROM Books ORDER BY Year"
      Top             =   600
      Width           =   4455
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Height          =   375
      Left            =   5520
      TabIndex        =   2
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox txtDatabase 
      Height          =   285
      Left            =   960
      TabIndex        =   1
      Top             =   120
      Width           =   4455
   End
   Begin VB.Label Label1 
      Caption         =   "Query"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   4
      Top             =   600
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Database"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_DBConnection As ADODB.Connection
' Connect to the database.
Private Sub cmdConnect_Click()
    ' If a database is currently open, close it.
    If Not m_DBConnection Is Nothing Then
        If m_DBConnection.State <> adStateClosed Then m_DBConnection.Close
    End If

    Set m_DBConnection = New ADODB.Connection
    m_DBConnection.ConnectionString = _
        "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=" & txtDatabase.Text & ";" & _
        "Persist Security Info=False"
    m_DBConnection.Open

    cmdExecute.Enabled = True
End Sub

Private Sub cmdExecute_Click()
Dim rs As ADODB.Recordset
Dim r As Integer
Dim c As Integer
Dim num_cols As Integer
Dim col_wid() As Single
Dim new_wid As Single

    ' Open the Recordset.
    Set rs = m_DBConnection.Execute( _
        txtCommand.Text, , adCmdText)

    ' Hide the grid.
    flxResults.Visible = False
    DoEvents

    ' Display the results.
    If rs.EOF Then
        flxResults.Rows = 1
        flxResults.Cols = 1
        flxResults.TextMatrix(0, 0) = "No Records Selected"
        num_cols = 1
        ReDim col_wid(0 To 0)
        col_wid(0) = TextWidth(flxResults.TextMatrix(0, 0))
    Else
        ' Make room for column widths.
        num_cols = rs.Fields.Count
        ReDim col_wid(0 To num_cols - 1)

        ' Set column headers.
        flxResults.Rows = 2
        flxResults.Cols = num_cols
        flxResults.FixedCols = 0
        flxResults.FixedRows = 1
        For c = 0 To num_cols - 1
            flxResults.TextMatrix(0, c) = rs.Fields(c).Name

            ' See if we need to enlarge the column.
            new_wid = TextWidth(rs.Fields(c).Name)
            If col_wid(c) < new_wid Then col_wid(c) = new_wid
        Next c

        ' Display the data.
        Do Until rs.EOF
            r = r + 1
            flxResults.Rows = r + 1
            For c = 0 To rs.Fields.Count - 1
                flxResults.TextMatrix(r, c) = rs.Fields(c).Value

                ' See if we need to enlarge the column.
                new_wid = TextWidth(rs.Fields(c).Value)
                If col_wid(c) < new_wid Then col_wid(c) = new_wid
            Next c
            rs.MoveNext
        Loop
    End If

    ' Set the grid's column widths.
    For c = 0 To num_cols - 1
        flxResults.ColWidth(c) = col_wid(c) + 120
    Next

    ' Display the grid.
    flxResults.Visible = True

    rs.Close
End Sub
Private Sub Form_Load()
Dim db_name As String

    db_name = App.Path
    If Right$(db_name, 1) <> "\" Then db_name = db_name & "\"
    db_name = db_name & "books.mdb"
    txtDatabase.Text = db_name
End Sub


' Make the grid control as large as possible.
Private Sub Form_Resize()
Dim hgt As Single

    hgt = ScaleHeight - flxResults.Top
    If hgt < 120 Then hgt = 120

    flxResults.Move 0, flxResults.Top, _
        ScaleWidth, hgt
End Sub


' Close the database.
Private Sub Form_Unload(Cancel As Integer)
    If Not m_DBConnection Is Nothing Then
        m_DBConnection.Close
    End If
End Sub


